<?php
/*
 * Formulaire SPIP CVT avec le plugin Saisies par l'exemple
 * voir : http://www.spip-contrib.net/.?article3665
 *
 */
function formulaires_film_charger_dist() {
// on charge les champs et les saisies qui nécessitent un accès par les fonctions
  $valeurs = array(
    'titre' => '',
    'annee' => '',
    'genre' => '',
    'c_bien' => '',
    'mes_saisies' => mes_saisies_film()
  );
  return $valeurs;
}

function formulaires_film_verifier_dist() {
  // on va chercher le pipeline saisies_verifier() dans son fichier
  include_spip('inc/saisies');
  // on récupère les saisies
  $mes_saisies = mes_saisies_film();
  // saisies_verifier retourne un tableau des erreurs s'il y en a, sinon traiter() prend le relais
  return saisies_verifier($mes_saisies);
}

function formulaires_film_traiter_dist() {
  // on charge les saisies, si besoin
  // $mes_saisies = mes_saisies_film();
  
  // Traitement des données reçues du formulaire, 
  // par mail par ex ou insertion dans une base
  //  ...
   
  // S'il y a des erreurs, elles sont retournées au formulaire
  // return array('message_erreur'=>'Le film n\'a pas été enregistré');
  
  // Sinon, le message de confirmation est envoyé
  return array('message_ok'=>'Le film a été enregistré');
}

function mes_saisies_film() {
  $mes_saisies = array(
    array(
      'saisie' => 'fieldset',
      'options' => array(
        'nom' => 'le_film',
        'label' => 'Le film'
      ),
      'saisies' => array(
        array(
            'saisie' => 'input',
            'options' => array(
              'nom' => 'titre',
              'label' => 'Son titre',
              'obligatoire' => 'oui'
            )
        ),
        array(
            'saisie' => 'input',
            'options' => array(
              'nom' => 'annee',
              'label' => 'Année de réalisation',
              'size' => 4,
              'maxlength' => 4
            ),
            'verifier' => array(
              'type' => 'entier',
              'options' => array (min => 1895, max => (date('Y')+1))
            )
        ),
        array(
          'saisie' => 'selection',
          'options' => array(
            'nom' => 'genre',
            'label' => 'Son genre',
            'datas' => array(  
// apparté : penser à ranger les choix par ordre alphabétique (ou numérique), c'est plus facile à trouver pour ceux qui utilisent le formulaire
              'animation' => 'Animation',
              'comedie' => 'Comédie',
              'docu' => 'Documentaire',
              'drame' => 'Drame',
              'sf' => 'Science-fiction'
            )
          )
        )
      )
    ),
    array(
      'saisie' => 'oui_non',
      'options' => array(
        'nom' => 'c_bien',
        'label' => 'C\'est bien ?'
      )
    ),
    array(
      'saisie' => 'mon_submit',
      'options' => array (
        'nom' => 'envoyer',
        'texte' => 'Ok'
      )
    )
  );
  return $mes_saisies;
}
?>